with Ada.Strings.Fixed;

package body P42.CFD.Java_Properties is

   ----------------
   -- Parse_File --
   ----------------

   overriding procedure Parse_File
     (Parser : in out Java_Parser_Type;
      File : Ada.Text_IO.File_Type)
   is
   begin
      loop
         exit when Ada.Text_IO.End_Of_File (File);
         declare
            Line : constant String := Ada.Text_IO.Get_Line (File);
            Pos_Equal : constant Natural := Ada.Strings.Fixed.Index (Line, "=");
            Pos_Comment : constant Natural := Ada.Strings.Fixed.Index (Line, "#");
            use Ada.Strings.Unbounded;
         begin
            if Line = "" then
               null;
            elsif Pos_Comment = 0 then
               if Pos_Equal = 0 then
                  raise Syntax_Error;
               end if;
               Parser.Elements.Append ((Key => To_Unbounded_String (Line (Line'First .. Pos_Equal - 1)),
                                        Value => To_Unbounded_String (Line (Pos_Equal + 1 .. Line'Last))));
            elsif Pos_Comment = 1 then -- Comment on the begin of the line
               null;
            else
               raise Bad_Comment_Syntax;
            end if;
         end;
      end loop;
   end Parse_File;

   ------------------
   -- Get_Elements --
   ------------------

   overriding function Get_Elements
     (Parser : Java_Parser_Type)
      return Java_Configuration_Package.Element_Vectors.Vector
   is
   begin
      return Parser.Elements;
   end Get_Elements;


   -------------
   -- Get_Key --
   -------------
   function Get_Key (Element : Java_Element_Type) return Ada.Strings.Unbounded.Unbounded_String is
   begin
      return Element.Key;
   end Get_Key;

end P42.CFD.Java_Properties;
