with Ada.Strings.Unbounded;
with P42.CFD;

pragma Elaborate_All (P42.CFD);

package P42.CFD.Java_Properties is

   type Java_Element_Type is record
      Key : Ada.Strings.Unbounded.Unbounded_String;
      Value : Ada.Strings.Unbounded.Unbounded_String;
   end record;

   function Get_Key (Element : Java_Element_Type) return Ada.Strings.Unbounded.Unbounded_String;

   package Java_Configuration_Package is
      new Configuration_Pkg (Java_Element_Type);

   type Java_Parser_Type is new Java_Configuration_Package.Parse_File_Interface with record
      Elements : Java_Configuration_Package.Element_Vectors.Vector;
   end record;
   overriding procedure Parse_File (Parser : in out Java_Parser_Type;
                                    File : Ada.Text_IO.File_Type);
   overriding function Get_Elements (Parser : Java_Parser_Type) return Java_Configuration_Package.Element_Vectors.Vector;

   Syntax_Error : exception;
   Bad_Comment_Syntax : exception;

end P42.CFD.Java_Properties;
