package body P42.CFD is

   -----------------------
   -- Configuration_Pkg --
   -----------------------

   package body Configuration_Pkg is

      ----------------------------------
      -- Configuration_Repository_Pkg --
      ----------------------------------

      package body Configuration_Repository_Pkg is

         ---------------------
         -- Repository_Type --
         ---------------------

         protected body Repository_Type is

            -----------
            -- Build --
            -----------

            procedure Build (File_Name : String) is
               Parser : Parser_Type;
               File : Ada.Text_IO.File_Type;
            begin
               Ada.Text_IO.Open (File, Ada.Text_IO.In_File, File_Name);
               Parser.Parse_File (File);
               Elements := Parser.Get_Elements;
               Ada.Text_IO.Close (File);
            end Build;

            -----------
            -- Clear --
            -----------

            procedure Clear is
            begin
               Elements.Clear;
            end Clear;

            ------------------
            -- Get_Elements --
            ------------------

            function Get_Elements return Element_Vectors.Vector is
            begin
               return Elements;
            end Get_Elements;

            ------------------------
            -- Get_Element_By_Key --
            ------------------------

            function Get_Element_By_Key (Key : Key_Type)
                                        return Element_Type is
            begin
               for Element of Elements loop
                  if Key = Get_Key (Element) then
                     return Element;
                  end if;
               end loop;
               raise Key_Not_Found;
            end Get_Element_By_Key;

         end Repository_Type;

      end Configuration_Repository_Pkg;

   end Configuration_Pkg;

end P42.CFD;
