--  with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with Ada.Text_IO;
--  with CSNSM.Print.Numeric; use CSNSM.Print.Numeric;

package body P42.Convert.Characters_2_Numeric is

   function Is_Numeric (Val : Character) return Boolean is
   begin
      return Val = '0'
        or Val = '1'
        or Val = '2'
        or Val = '3'
        or Val = '4'
        or Val = '5'
        or Val = '6'
        or Val = '7'
        or Val = '8'
        or Val = '9';
   end Is_Numeric;

   package body Generic_Char2Num is

      function Read_Hex_Interne (Val : Unbounded_String) return T_Number is
         Tmp_Val : constant String := To_String (Val);
         Hex_Char : constant String := Tmp_Val (Tmp_Val'First .. Tmp_Val'First  + 1);
      begin
         begin
            if Hex_Char /= "0X" and Hex_Char /= "0x" then
               raise Constraint_Error;
            end if;
         exception
            when Ada.Strings.Index_Error =>
               raise Constraint_Error;
         end;
         return T_Number'Value ("16#"
                                 &  Tmp_Val (Tmp_Val'First + 2 .. Tmp_Val'Length)
                                 & "#");
      end Read_Hex_Interne;

      function Read_Dec_Interne (Val : Unbounded_String) return T_Number is
      begin
         return T_Number'Value (Ada.Strings.Unbounded.To_String (Val));
      end Read_Dec_Interne;

      function Read_Dec (Val : Unbounded_String) return T_Number is
      begin
         return Read_Dec_Interne (Val);
      exception
         when Constraint_Error =>
            Ada.Text_IO.Put_Line (">" & To_String (Val)
                                    & "< : Wrong kind of arguments.");
            Ada.Text_IO.Put_Line ("Should be a decimal number.");
            Ada.Text_IO.New_Line;
            raise Wrong_Type;
      end Read_Dec;

      function Read_Hex (Val : Unbounded_String) return T_Number is
      begin
         return Read_Hex_Interne (Val);
      exception
         when Constraint_Error =>
            Ada.Text_IO.Put_Line (">" & To_String (Val)
                                    & "< : Wrong kind of arguments.");
            Ada.Text_IO.Put_Line ("Should be an hexadecimal number.");
            Ada.Text_IO.New_Line;
            raise Wrong_Type;
      end Read_Hex;

      function Read_Hex_Dec (Val : Unbounded_String) return T_Number is
      begin
         --     Ada.Text_IO.Put_Line ("Val  convertir (Hex/Dec) : " & To_String (Val));
         return Read_Hex_Interne (Val);
      exception
         when Constraint_Error =>
            begin
               return Read_Dec_Interne (Val);
            exception
               when Constraint_Error =>
                  Ada.Text_IO.Put_Line (">" & To_String (Val)
                                          & "< : Wrong kind of arguments. ??");
                  Ada.Text_IO.Put_Line ("Should be a number.");
                  Ada.Text_IO.New_Line;
                  raise Wrong_Type;
            end;
      end Read_Hex_Dec;
   end Generic_Char2Num;
end P42.Convert.Characters_2_Numeric;
