package body P42.Convert.Generic_Numeric_2_Characters is

   function Number_To_String (N : Numeric_Type; B : T_Base) return String is
   begin

      --  Warning : Base'Pos (Base_2) = 0 !!!
      return To_String (Base_To_String (N, T_Base'Pos (B) + 2));
   end Number_To_String;

   function Base_To_String (N : Numeric_Type; Base : Numeric_Type)
                           return Unbounded_String is
      Tmp : Numeric_Type := N;
      Val_Return : Unbounded_String := Null_Unbounded_String;
   begin
      while (Tmp > (Base - 1)) loop
         Val_Return := Numeric_To_String (Tmp rem Base) & Val_Return;
         Tmp := Tmp / Base;
      end loop;
      return Numeric_To_String (Tmp) & Val_Return;
   end Base_To_String;

   function Preformat (S : Unbounded_String; Width : Natural)
                      return Unbounded_String is
      Val_Return : Unbounded_String := S;
   begin
      for I in 1 .. (Width - Length (Val_Return)) loop
         Val_Return := "0" & Val_Return;
      end loop;
      return Val_Return;
   end Preformat;

   function Numeric_To_String (N : Numeric_Type) return Unbounded_String is
   begin
      if (N < 10) then
         return To_Unbounded_String (Numeric_Type'Image (N) (2 .. 2));
      else
         if N > 36 then
            raise Out_Of_Bound;
         else
            return To_Unbounded_String (Alphabet'Image (Alphabet'Val (N - 10)));
         end if;
      end if;
   end Numeric_To_String;
end P42.Convert.Generic_Numeric_2_Characters;
