with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

package body P42.Convert.Numeric_2_Characters.Hexadecimal is

   function Hexa_To_String (N : Natural; Width : Natural := 0) return String is
      Val_Return : Unbounded_String := Null_Unbounded_String;
   begin
      Val_Return := Base_To_String (N, Natural (T_Hexadecimal'Last) + 1);
      Val_Return := Preformat (Val_Return, Width);
      return Format (To_String (Val_Return));
   end Hexa_To_String;

   function To_Hexa (N : Natural; Width : Natural := 0) return String is
      Val_Return : Unbounded_String := Null_Unbounded_String;
   begin
      Val_Return := Base_To_String (N, Natural (T_Hexadecimal'Last) + 1);
      Val_Return := Preformat (Val_Return, Width);
      return To_String (Val_Return);
   end To_Hexa;

   function Format (S : String) return String is
   begin
      return "0x" & S;
   end Format;

   function Ada_Format (S : String) return String is
   begin
      return "16#" & S & "#";
   end Ada_Format;

   function C_To_Ada_Format (S : String) return String is
      Tmp : Unbounded_String := To_Unbounded_String (S);
   begin
      if (S'Last > 2) then
         if (S (S'First + 1 .. S'First + 1) = "X" or S (S'First + 1 .. S'First + 1) = "x") then
            Tmp := "16#" & To_Unbounded_String (S (S'First + 2 .. S'Last)) & "#";
         end if;
      end if;
      return To_String (Tmp);
   end C_To_Ada_Format;
end P42.Convert.Numeric_2_Characters.Hexadecimal;
