--  This package allows to write a number in non standard base from base_2 to base_16
--  @version 1.0.0


with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

package P42.Convert.Numeric_2_Characters is

   --  Write the number N in a string using the base B
   --  @parameter N : Number to write back
   --  @parameter B : Base to use
   --  @return : String
   --  @exception P42.Convert.Wrong_type
   function Number_To_String (N : Natural; B : T_Base) return String;

private
   --  Write the number N in a string using the base B
   --  @parameter N : Number to write back
   --  @parameter B : Base to use
   --  @return : Unbounded_String
   --  @exception P42.Convert.Wrong_type
   function Base_To_String (N : Natural; Base : Natural)
                           return Unbounded_String;
   --  Add the right number of character to obtain a String with the right width
   --  @parameter S : Base string
   --  @parameter Width : Width to reach
   --  @return : Unbounded_String
   function Preformat (S : Unbounded_String; Width : Natural)
                      return Unbounded_String;
   --  Convert into a digit a number. Number MUST be lower than 36 (10 + alphabet'length)
   --  @parameter N : Number to write
   --  @return : Digit in right format
   function Numeric_To_String (N : Natural) return Unbounded_String;
end P42.Convert.Numeric_2_Characters;
