with Ada.Strings.Unbounded;

package P42.Html_Utils is

   type T_Page_Html is tagged record
      Header : Ada.Strings.Unbounded.Unbounded_String;
      Body_Page : Ada.Strings.Unbounded.Unbounded_String;
   end record;

   procedure Append_Code (Obj : in out T_Page_Html;
                          Code : String;
                          LF : Boolean := True);
   procedure Append_Code (Obj : in out T_Page_Html;
                          Code : Ada.Strings.Unbounded.Unbounded_String;
                          LF : Boolean := True);
   procedure Append_Code_Tagged (Obj : in out T_Page_Html;
                                 Tag : String;
                                 Code : String;
                                 LF : Boolean := True);
   procedure Append_Head (Obj : in out T_Page_Html;
                          Code : Ada.Strings.Unbounded.Unbounded_String;
                          LF : Boolean := True);
   procedure Append_Head (Obj : in out T_Page_Html;
                          Code : String;
                          LF : Boolean := True);
   procedure Head (Obj : in out T_Page_Html;
                   Title : String;
                   CSS_URI : String := "";
                   Refresh : Duration := 0.0;
                   Url : String := "");

   procedure Malformed_URI (Obj : in out T_Page_Html;
                            Sub_URI : String);

   function Return_Page (Obj : T_Page_Html) return Ada.Strings.Unbounded.Unbounded_String;
end P42.Html_Utils;
