with Interfaces;
package P42.Images
  with Pure => True is
   type General_Kind_Enum is (Byte,
                              Ascii,
                              Short,
                              Long,
                              Rational,
                              Sbyte,
                              Undefined,
                              Sshort,
                              Slong,
                              Srational,
                              Float,
                              Double,
                              Slonglong);  -- needed for fits
   for General_Kind_Enum use (Byte      => 1,
                              Ascii     => 2,
                              Short     => 3,
                              Long      => 4,
                              Rational  => 5,
                              Sbyte     => 6,
                              Undefined => 7,
                              Sshort    => 8,
                              Slong     => 9,
                              Srational => 10,
                              Float     => 11,
                              Double    => 12,
                              Slonglong => 13);
   for General_Kind_Enum'Size use 16;

   Invalid_File : exception;
   Unsupported_Feature : exception;

   type Byte_Array is array (Positive range <>) of Interfaces.Unsigned_8;
   type Sshort_Array is array (Positive range <>) of Interfaces.Integer_16;
   type Long_Array is array (Positive range <>) of Interfaces.Unsigned_32;
   type Slong_Array is array (Positive range <>) of Interfaces.Integer_32;
   type Longlong_Array is array (Positive range <>) of Interfaces.Unsigned_64;
   type Slonglong_Array is array (Positive range <>) of Interfaces.Integer_64;
   type Float_Array is array (Positive range <>) of Interfaces.IEEE_Float_32;
   type Double_Array is array (Positive range <>) of Standard.Long_Float;

   type Byte_Matrix is array (Positive range <>, Positive range <>) of Interfaces.Unsigned_8;
   type Sshort_Matrix is array (Positive range <>, Positive range <>) of Interfaces.Integer_16;
   type Slong_Matrix is array (Positive range <>, Positive range <>) of Interfaces.Integer_32;
   type Slonglong_Matrix is array (Positive range <>, Positive range <>) of Interfaces.Integer_64;
   type Float_Matrix is array (Positive range <>, Positive range <>) of Interfaces.IEEE_Float_32;
   type Double_Matrix is array (Positive range <>, Positive range <>) of Standard.Long_Float;

   type Selection_Pattern is array (Positive range <>) of Boolean
     with Pack => True;

   function To_String (Pattern : Selection_Pattern) return String
     with Post => Pattern'Length = To_String'Result'Length;

   function To_Pattern (Pattern_Image : String) return Selection_Pattern
     with Post => Pattern_Image'Length = To_Pattern'Result'Length;

end P42.Images;
