with POSIX.C;
with POSIX.Message_Queues;

generic
   type Message_Type (<>) is private;
   Default_Priority : Integer := 15;
package P42.Messages_Queues is

   procedure Send (Queue : POSIX.Message_Queues.Message_Queue_Descriptor;
                   Message : Message_Type);

   function Receive (Queue : POSIX.Message_Queues.Message_Queue_Descriptor) return Message_Type;

   function Timed_Receive
     (Queue : POSIX.Message_Queues.Message_Queue_Descriptor;
      Abs_Timeout : POSIX.C.struct_timespec)
     return Message_Type;
   function Relative_Timed_Receive
     (Queue : POSIX.Message_Queues.Message_Queue_Descriptor;
      Relative_Timeout : Natural)
     return Message_Type;
   function Relative_Timed_Receive
     (Queue : POSIX.Message_Queues.Message_Queue_Descriptor;
      Relative_Timeout : Duration)
     return Message_Type;

end P42.Messages_Queues;
