with GNAT.OS_Lib;
with GNAT.Directory_Operations;

with P42.String_Manipulation;

package body P42.OS_Lib is

   procedure Check_And_Create (Dir_Name : String) is
   begin
      if GNAT.OS_Lib.Is_Directory (Dir_Name) then
         return;
      end if;
      if GNAT.OS_Lib.Is_Regular_File (Dir_Name) then
         raise Error with Dir_Name & " is already an existing regular file";
      end if;
      declare
         Working_Dir : constant String :=
           String_Manipulation.Remove_Character (Dir_Name, '/', String_Manipulation.Ending);
         Sub_Dir : constant String := GNAT.Directory_Operations.Dir_Name (Working_Dir);
      begin
         Check_And_Create (Sub_Dir);
         GNAT.Directory_Operations.Make_Dir (Dir_Name);
      end;
   end Check_And_Create;

end P42.OS_Lib;
