package body P42.Streams is

   use type Ada.Streams.Stream_Element_Offset;

   procedure Read (Stream : in out Streamer_Type;
                   Item   : out Ada.Streams.Stream_Element_Array;
                   Last   : out Ada.Streams.Stream_Element_Offset) is
      New_First : constant Ada.Streams.Stream_Element_Offset :=
        Stream.First + Item'Length;
   begin
      if Stream.First > Stream.Last then
         raise Stream_IO_Error with "read error";
      end if;
      Item := Stream.Data (Stream.First .. New_First - 1);
      Stream.First := New_First;
      Last := Item'Last;
   end Read;

   procedure Write (Stream : in out Streamer_Type;
                    Item   : in Ada.Streams.Stream_Element_Array) is
      New_Last : constant Ada.Streams.Stream_Element_Offset :=
        Stream.Last + Item'Length;
   begin
      if New_Last >= Stream.Data'Last then
         raise Stream_IO_Error with "write error";
      end if;
      Stream.Data (Stream.Last + 1 .. New_Last) := Item;
      Stream.Last := New_Last;
   end Write;

   procedure Initialise (Stream : in out Streamer_Type) is
   begin
      Stream.First := Stream.Data'First;
      Stream.Last := Stream.Data'First - 1;
   end Initialise;

end P42.Streams;
