with Ada.Streams;

package P42.Streams is

   type Streamer_Type (Data_Length : Ada.Streams.Stream_Element_Offset) is
     new Ada.Streams.Root_Stream_Type with record
      First : Ada.Streams.Stream_Element_Offset := 1;
      Last : Ada.Streams.Stream_Element_Offset;
      Data : Ada.Streams.Stream_Element_Array (1 .. Data_Length);
   end record;

   procedure Read (Stream : in out Streamer_Type;
                   Item   : out Ada.Streams.Stream_Element_Array;
                   Last   : out Ada.Streams.Stream_Element_Offset);

   procedure Write (Stream : in out Streamer_Type;
                    Item   : in Ada.Streams.Stream_Element_Array);
   procedure Initialise (Stream : in out Streamer_Type);

   Stream_IO_Error : exception;

end P42.Streams;
