with P42.String_Couple_Vectors;
with P42.String_Vectors;

package P42.String_Manipulation is
   pragma Preelaborate;

   function Substitute (Source : String;
                        Origin : String;
                        By : String;
                        Recursive : Boolean := False) return String;

   function Substitute (Source : String;
                        Templates : P42.String_Couple_Vectors.Vector;
                        Recursive : Boolean := False) return String;

   function Substitute_Regexp (Source : String;
                               Regexp : String;
                               By : String;
                               Recursive : Boolean := False) return String;

   type Position_Enum is (Beginning, Ending, Both);

   function Remove_Character (Source : String;
                              C : Character;
                              Where : Position_Enum := Both) return String;
   function Remove_Spaces (Source : String; Where : Position_Enum := Both) return String is
      (Remove_Character (Source, ' ', Where));

   function To_List (Source : P42.String_Vectors.Vector;
                     Separator : String := " ") return String;

end P42.String_Manipulation;
