with Ada.Streams;
with System;

package body P42.Swap is

   use type Ada.Streams.Stream_Element_Offset;

   subtype Stream_Item is Ada.Streams.Stream_Element_Array (1 .. Item_Type'Size / 8);

   ---------------
   -- Swap_Item --
   ---------------

   procedure Swap_Item (Item : in out Item_Type) is
      Data : Stream_Item;
      for Data'Address use Item'Address;
      Middle : constant Ada.Streams.Stream_Element_Offset := Data'Length / 2;
      Temp_Value : Ada.Streams.Stream_Element;
   begin
      for I in Data'First .. Middle loop
         Temp_Value := Data (I);
         Data (I) := Data (Data'Last + Data'First - I);
         Data (Data'Last + Data'First - I) := Temp_Value;
      end loop;
   end Swap_Item;

   ---------------
   -- Swap_Item --
   ---------------

   function Swap_Item (Item : Item_Type) return Item_Type is
      Return_Item : Item_Type;
      Source : Stream_Item;
      for Source'Address use Item'Address;
      Data : Stream_Item;
      for Data'Address use Return_Item'Address;
   begin
      for I in Source'Range loop
         Data (I) := Source (Data'Last + Data'First - I);
      end loop;
      return Return_Item;
   end Swap_Item;

   function To_Big_Endian (Item : Item_Type) return Item_Type is
      use System;
   begin
      if Default_Bit_Order = Low_Order_First then
         return Swap_Item (Item);
      else
         return Item;
      end if;
   end To_Big_Endian;

end P42.Swap;
