with Ada.Command_Line;
with Ada.Containers;
with Ada.Text_IO;

with GNAT.Command_Line;

with P42.Images.Fits;

procedure Analyse_Fits is
   Options : constant String := "help file=";
   use type Ada.Containers.Count_Type;
begin
   loop
      case GNAT.Command_Line.Getopt (Options) is
         when ASCII.NUL =>
            exit;
         when 'f' =>
            declare
               Image : constant P42.Images.Fits.Image_Type :=
                 P42.Images.Fits.Read_Image (GNAT.Command_Line.Parameter);
               --  Min : Float := Float'Last;
               --  Max : Float := Float'First;
            begin
               for Keyword of Image.Keywords loop
                  Ada.Text_IO.Put_Line (Keyword.Raw);
               end loop;
               Ada.Text_IO.Put_Line ("Bitpix " & Image.Bitpix'Img);
               Ada.Text_IO.Put_Line ("Naxis :" & Image.Naxis'Img);
               if Image.Naxis = 1 then
                  Ada.Text_IO.Put_Line ("axis 1:" & Image.Naxis1'Img);
               elsif Image.Naxis = 2 then
                  Ada.Text_IO.Put_Line ("axis 1:" & Image.Naxis1'Img);
                  Ada.Text_IO.Put_Line ("axis 2:" & Image.Naxis2'Img);
               elsif Image.Naxis = 3 then
                  Ada.Text_IO.Put_Line ("axis 1:" & Image.Naxis1'Img);
                  Ada.Text_IO.Put_Line ("axis 2:" & Image.Naxis2'Img);
                  Ada.Text_IO.Put_Line ("axis 3:" & Image.Naxis3'Img);
               end if;
               Ada.Text_IO.Put_Line ("datas length :" & Image.Datas.Length'Img);
               for Data of Image.Datas loop
                  Ada.Text_IO.Put_Line ("# of rows :" & Data.Length'Img);
                  Ada.Text_IO.Put_Line ("# of column :" & Data.First_Element.Length'Img);
               end loop;
            end;
         when 'h' =>
            Ada.Text_IO.Put_Line (Ada.Command_Line.Command_Name & " {-help|-file=file_name.tiff}");
            return;
         when others =>
            raise Program_Error;
      end case;
   end loop;
end Analyse_Fits;
