with Ada.Calendar;

with P42.Gnuplot;

procedure Build_Graph is
   package Gnuplot_Int is new P42.Gnuplot (Integer, Integer'Image);
   package Gnuplot_Long_Float is new P42.Gnuplot (Long_Float, Long_Float'Image);
   Some_Points : constant Gnuplot_Int.Two_D_Point_Array (1 .. 7) :=
     (1 => (1, 1),
      2 => (2, 4),
      3 => (3, 9),
      4 => (4, 16),
      5 => (5, 25),
      6 => (6, 36),
      7 => (7, 49));
   Datas : constant Gnuplot_Int.Data_Type :=
     (Dimension => Gnuplot_Int.Two_D,
      Point_Nb => Some_Points'Length,
      Two_D_Points => Some_Points);
   Some_3D_Points : Gnuplot_Long_Float.Three_D_Point_Array (1 .. 100);
   Increment : constant Long_Float := 0.1;
   X : Long_Float := 0.0;
   Y : Long_Float := 0.0;
   Index : Gnuplot_Long_Float.Point_Number_Type := 1;
   Some_Timed_Points : Gnuplot_Int.Timed_Point_Array (1 .. 10);
begin
   Gnuplot_Int.Generate (Title => "nice title",
                         Xlabel => "time",
                         Ylabel => "temperature",
                         Datas => Datas);
   Gnuplot_Int.Generate (File_Name => "nice_png2.png",
                         Title => "nice title",
                         Xlabel => "time",
                         Ylabel => "temperature",
                         Datas => Datas);
   for I in 1 .. 10 loop
      for J in 1 .. 10 loop
         Some_3D_Points (Index) := (X, Y, X**2 * Y**2);
         X := X + Increment;
         if X >= 1.0 then
            X := 0.0;
         end if;
         Index := Index + 1;
      end loop;
      Y := Y + Increment;
   end loop;
   declare
      Datas_3D : constant Gnuplot_Long_Float.Data_Type :=
        (Dimension => Gnuplot_Long_Float.Three_D,
         Point_Nb => Some_3D_Points'Length,
         Three_D_Points => Some_3D_Points);
   begin
      Gnuplot_Long_Float.Generate (Title => "nice title 3D",
                                   Xlabel => "time",
                                   Ylabel => "temperature",
                                   Zlabel => "neuh",
                                   Datas => Datas_3D);
   end;
   for I in Some_Timed_Points'Range loop
      Some_Timed_Points (I) := (Ada.Calendar.Clock, I);
      delay 2.0;
   end loop;

   declare
      Datas_Timed : constant Gnuplot_Int.Data_Type :=
        (Dimension => Gnuplot_Int.Timed,
         Point_Nb => Some_Timed_Points'Length,
         Timed_Points => Some_Timed_Points);
   begin
      Gnuplot_Int.Generate (Title => "nice timed graph",
                            Xlabel => "time",
                            Ylabel => "Y",
                            Datas => Datas_Timed);
   end;
end Build_Graph;
