with Ada.Command_Line;
with Ada.Exceptions;
with Ada.Text_IO;

with GNAT.Traceback.Symbolic;

with P42.Sha384;

procedure Sha384sum is
begin

   for I in 1 .. Ada.Command_Line.Argument_Count loop
      declare
         Context : P42.Sha384.Context_Type;
         File_Name : constant String := Ada.Command_Line.Argument (I);
      begin
         P42.Sha384.Hash_Computation (Context, File_Name);
         Ada.Text_IO.Put_Line (P42.Sha384.Image (Context) & "  " & File_Name);
      end;
   end loop;
exception
   when E : others =>
      Ada.Text_IO.Put_Line ("unexpected exception : " & Ada.Exceptions.Exception_Name (E));
      Ada.Text_IO.Put_Line ("                       " & Ada.Exceptions.Exception_Message (E));
      Ada.Text_IO.Put_Line (GNAT.Traceback.Symbolic.Symbolic_Traceback (E));
end Sha384sum;
