with Ada.Strings.Unbounded;

with GNAT.Command_Line;

with P42.Images.Convert;
with P42.Images.Fits;
with P42.Images.Tiff;

procedure P42.Tools.To_Fits is
   Options : constant String := "tiff= fits=";
   Fits_Name : Ada.Strings.Unbounded.Unbounded_String;
   File_Set : Boolean := False;
   Fits_Image : Images.Fits.Image_Type;
   use Ada.Strings.Unbounded;
begin
   loop
      case GNAT.Command_Line.Getopt (Options) is
         when ASCII.NUL =>
            exit;
         when 'f' =>
            Fits_Name := To_Unbounded_String (GNAT.Command_Line.Parameter);
         when 't' =>
            File_Set := True;
            declare
               Tiff_Image : constant Images.Tiff.Image_Type :=
                 Images.Tiff.Image (GNAT.Command_Line.Parameter);
            begin
               Fits_Image := Images.Convert.To_Fits (Tiff_Image);
            end;
         when others =>
            raise Program_Error;
      end case;
   end loop;
   if not File_Set then
      raise Program_Error with "option -tiff is mandatory to provide tiff file";
   end if;
   if Fits_Name = Null_Unbounded_String then
      raise Program_Error with "option -fits is mandatory to provide output file name";
   end if;
   Images.Fits.Write (Fits_Image, To_String (Fits_Name));
end P42.Tools.To_Fits;
